#ifndef TT_TEMPORALY_ARRAY_H_
#define TT_TEMPORALY_ARRAY_H_

template <class TYPE>
class TtTemporalyArray {
public:
  explicit TtTemporalyArray( unsigned int count ) :
  size_( sizeof( TYPE ) * count ),
  ptr_( new TYPE[size_] ) {
  }

  virtual ~TtTemporalyArray() {
    delete[] ptr_;
  }

  unsigned int GetCount( void ) const {
    return size_ / sizeof( TYPE );
  }
  
  unsigned int GetSize( void ) const {
    return size_;
  }

  TYPE* GetPtr( void ) const {
    return ptr_;
  }

protected:
  unsigned int size_;
  TYPE*        ptr_;
};


class TtTemporalyString : public TtTemporalyArray<char>
{
public:
  explicit TtTemporalyString( unsigned int size );

  void ExtendSize( unsigned int increasing );
};

#endif // TT_TEMPORALY_ARRAY_H_
