#ifndef TT_UTIL_H_
#define TT_UTIL_H_

#include <string>
#include <sstream>

namespace TtUtil {
  bool StringToInteger( const std::string& str, int* ret, unsigned int base );
  bool StringToDouble( const std::string& str, double* ret );

  std::string StringReplace( const std::string& source, const std::string& pattern, const std::string& replacement );

  template <class TYPE>
  std::string ToStringFrom( TYPE value ) {
    std::ostringstream os;
    os << value;
    return os.str();
  }

  template <class TYPE>
  TYPE& Bigger( TYPE& r, TYPE& l ) {
    return r > l ? r : l;
  }

  template <class TYPE>
  const TYPE& ConstBigger( const TYPE& r, const TYPE& l ) {
    return r > l ? r : l;
  }

  template <class TYPE>
  TYPE& Smaller( TYPE& r, TYPE& l ) {
    return r > l ? l : r;
  }

  template <class TYPE>
  const TYPE& ConstSmaller( const TYPE& r, const TYPE& l ) {
    return r > l ? l : r;
  }

  std::string GetWindowsSystemErrorMessage( unsigned int error_number );

  std::string BccCompilerDateMacroToNormalString( const std::string& date );
#define TTL_DATE_STRING TtUtil::BccCompilerDateMacroToNormalString( __DATE__ )

  void MessageBoxForDebug( const char* type, const char* obj_name, void* obj, const char* file, int line );
}

#endif // TT_UTIL_H_
