#ifndef TT_WINDOW_CONTROLS_H_
#define TT_WINDOW_CONTROLS_H_

#include "tt_window.h"

// -- TtStatic -----------------------------------------------------------
class TtStatic : public TtWindow {
protected:
  virtual DWORD  GetStyle( void );
  virtual DWORD  GetExtendedStyle( void );
  virtual PCTSTR GetClassName( void );
};

// -- TtButton -----------------------------------------------------------
class TtButton : public TtWindow {
protected:
  virtual DWORD  GetStyle( void );
  virtual DWORD  GetExtendedStyle( void );
  virtual PCTSTR GetClassName( void );
};

// -- TtButtonWithCheck --------------------------------------------------
class TtButtonWithCheck : public TtButton {
public:
  bool GetCheck( void );
  int SetCheck( bool checking );
};

// -- TtRadioButton ------------------------------------------------------
class TtRadioButton : public TtButtonWithCheck {
protected:
  virtual DWORD  GetStyle( void );
};


// -- TtCheckBox ----------------------------------------------------------
class TtCheckBox : public TtButtonWithCheck {
protected:
  virtual DWORD  GetStyle( void );
};

// -- TtGroup ------------------------------------------------------------
class TtGroup : public TtButton {
protected:
  virtual DWORD  GetStyle( void );
};

// -- TtEdit -------------------------------------------------------------
class TtEdit : public TtWindow {
protected:
  virtual DWORD  GetStyle( void );
  virtual DWORD  GetExtendedStyle( void );
  virtual PCTSTR GetClassName( void );

public:
  void SetReadOnly( bool flag );

  int GetFirstVisibleLine( void );
};

// -- TtEditNumber -------------------------------------------------------
class TtEditNumber : public TtEdit {
protected:
  virtual DWORD GetStyle( void );
};

// -- TtEditMultiline ----------------------------------------------------
class TtEditMultiline : public TtEdit {
protected:
  virtual DWORD GetStyle( void );
};


#endif // TT_WINDOW_CONTROLS_H_
